package cn.iocoder.yudao.module.bpm.service.oa;

import cn.iocoder.yudao.module.bpm.controller.admin.oa.vo.evection.BpmOAEvectionCreateReqVO;
import cn.iocoder.yudao.module.bpm.dal.dataobject.oa.BpmOAEvectionDO;

import javax.validation.Valid;
import java.time.LocalDate;
import java.util.List;

public interface BpmOAEvectionService {

    /**
     * 创建出差申请
     *
     * @param userId 用户编号
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createEvection(Long userId, @Valid BpmOAEvectionCreateReqVO createReqVO);

    /**
     * 更新出差申请的状态
     *
     * @param id 编号
     * @param result 结果
     */
    void updateEvectionResult(Long id, Integer result);

    /**
     * 获得出差申请
     *
     * @param id 编号
     * @return 出差申请
     */
    BpmOAEvectionDO getEvection(Long id);

    /**
     * 获得指定的出差申请
     * @param processInstanceId 流程实例编号
     * @return 出差申请
     */
    BpmOAEvectionDO getByProcessInstanceId(String processInstanceId);

    /**
     * 获得指定开始时间的出差申请列表
     * @param date 当前日期
     * @return 出差申请列表
     */
    List<BpmOAEvectionDO> getEvectionListByStartTime(LocalDate date);

    /**
     * 获得指定结束时间的出差申请列表
     * @param date 当前日期
     * @return 出差申请列表
     */
    List<BpmOAEvectionDO> getEvectionListByEndTime(LocalDate date);

    /**
     * 获得我的出差申请列表
     * @return 出差申请列表
     */
    List<BpmOAEvectionDO> getEvectionList();
}
